(*
 *  beware IRC services, objbot.pas
 *  Copyright (C) 2002-2005 Bas Steendijk and Peter Green
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)
unit objbot;

interface
  //uses
  //  sysutils,
  //  bservicemngr;
  uses
    sysutils , bservicemngr , pgtypes   , buser , bparse , bstuff , bcmds ,
    bchannel , bservunit    , blinklist ;

  type
    tobjbot=class
    public
      up : boolean;
      srvunit : tserviceunit;
      constructor create;
      destructor destroy;override;
      procedure setupsrvunit;virtual;
    end;


implementation

procedure onstartup(tag:taddrint);
begin
  with tobjbot(tag) do begin
    if up then exit;
    up := true;
    //mybot := addbot(srvunit,nick,userid,host,realname,0);
    //prefix := sendprefixstr(mybot);
  end;
end;

procedure onshutdown(tag:taddrint);
begin
  with tobjbot(tag) do begin
    if not up then exit;
    up := false;

    //bot_quit(mybot,shutdownreason);
    //mybot := nil;
  end;
end;



procedure tobjbot.setupsrvunit;
begin
  if not assigned(srvunit) then srvunit := createserviceunit;
  //srvunit.name := 'invkickbot';
  srvunit.onstartup := onstartup;
  //srvunit.onparse   := onparse;
  //srvunit.oninvite  := oninvite;
  //srvunit.onleavechannel := onleavechannel;
  srvunit.onshutdown := onshutdown;
  //srvunit.onprivmsg := onprivmsg;
  //srvunit.ontimer := ontimer;
  //srvunit.onsave := onsave;
  //srvunit.onaccount := onaccount;
  //srvunit.ondestroyuser := ondestroyuser;
  //srvunit.onrehash := onrehash;
  srvunit.tag := taddrint(self);

end;
constructor tobjbot.create;
begin
  inherited create;

  setupsrvunit;
  if not registerserviceunit(srvunit) then begin
    raise exception.create('unable to register service unit');
  end;

end;

destructor tobjbot.destroy;

begin
  inherited destroy;
end;



end.
